<script setup>
import { Head, Link } from '@inertiajs/vue3';
import { ref } from 'vue';

defineProps({
    canLogin: {
        type: Boolean,
    },
    canRegister: {
        type: Boolean,
    },
});

const selectedText = ref('');

function getSelection() {
    var range = document.getSelection().getRangeAt(0);
    selectedText.value = window.getSelection().toString();
    // console.log(range);
    // console.log({
    //     'collapsed' : range.collapsed,
    //     'commonAncestorContainer' : range.commonAncestorContainer, 
    //     'endContainer' : range.endContainer, 
    //     'endOffset': range.endOffset, 
    //     'startContainer' : range.startContainer, 
    //     'startOffset' : range.startOffset
    // });
    // keep it inside commonAncestorContainer
    // start highlight from startContainer && startOffset
    // ends highlight at endContainer && endOffset
    var highlight = "Off";
    walk(range.commonAncestorContainer, (node) => {
        if (node.nodeType == 3) {
            if (node.isSameNode(range.startContainer) && !node.isSameNode(range.endContainer)) {
                highlight = "Start";
                let mark = document.createElement("mark");
                let value = node.nodeValue.substring(range.startOffset);
                let insertBeforeTextNode = document.createTextNode(node.nodeValue.substring(0, range.startOffset));
                let mark_content = document.createTextNode(value);
                mark.appendChild(mark_content);
                let parentNode = node.parentNode; 
                let marked = node.parentNode.replaceChild(mark, node);
                if (insertBeforeTextNode != "") {
                    parentNode.insertBefore(insertBeforeTextNode, mark);
                }
            }

            if (node.isSameNode(range.endContainer)) {
                highlight = "Off";
                let mark = document.createElement("mark");
                let value = "";
                let insertBeforeTextNode = "";
                if (range.startContainer.isSameNode(range.endContainer)) {
                    insertBeforeTextNode = document.createTextNode(node.nodeValue.substring(0, range.startOffset));
                    value = node.nodeValue.substring(range.startOffset, range.endOffset);
                } else {
                    value = node.nodeValue.substring(0, range.endOffset);
                }
                let insertAfterTextNode = document.createTextNode(node.nodeValue.substring(range.endOffset));
                let mark_content = document.createTextNode(value);
                mark.appendChild(mark_content);
                let parentNode = node.parentNode; 
                let marked = node.parentNode.replaceChild(mark, node);
                if (insertBeforeTextNode != "") {
                    parentNode.insertBefore(insertBeforeTextNode, mark);
                }
                if (insertAfterTextNode != "") {
                    parentNode.insertBefore(insertAfterTextNode, mark.nextSibling);
                }
            }
            if (highlight == "ON") {
                let mark = document.createElement("mark");
                let value = node.nodeValue;
                let mark_content = document.createTextNode(value);
                mark.appendChild(mark_content);
                node.parentNode.replaceChild(mark, node);
            }
            if (highlight = "Start") {
                highlight = "ON";
            }
        }
    });
}
function walk(node, func) {
   var children = node.childNodes;
   for (var i = 0; i < children.length; i++)  // Children are siblings to each other
       walk(children[i], func);
   func(node);
}
</script>

<template>
    <Head title="Marked Document" />

    <div
        class="relative sm:flex sm:justify-center sm:items-center min-h-screen bg-dots-darker bg-center bg-gray-100 dark:bg-dots-lighter dark:bg-gray-900 selection:bg-red-500 selection:text-white"
    >
        <div v-if="canLogin" class="sm:fixed sm:top-0 sm:right-0 p-6 text-right">
            <Link
                :href="route('marked_document')"
                class="ml-4 cursor-pointer font-semibold text-gray-600 hover:text-gray-900 dark:text-gray-400 dark:hover:text-white focus:outline focus:outline-2 focus:rounded-sm focus:outline-red-500"
                >Marked Document</Link
            >
            <Link
                :href="route('highlighted_document')"
                class="ml-4 cursor-pointer font-semibold text-gray-600 hover:text-gray-900 dark:text-gray-400 dark:hover:text-white focus:outline focus:outline-2 focus:rounded-sm focus:outline-red-500"
                >Highlighted Document</Link
            >

            <Link
                v-if="$page.props.auth.user"
                :href="route('dashboard')"
                class="ml-4 cursor-pointer font-semibold text-gray-600 hover:text-gray-900 dark:text-gray-400 dark:hover:text-white focus:outline focus:outline-2 focus:rounded-sm focus:outline-red-500"
                >Dashboard</Link
            >

            <template v-else>
                <Link
                    :href="route('login')"
                    class="ml-4 cursor-pointer font-semibold text-gray-600 hover:text-gray-900 dark:text-gray-400 dark:hover:text-white focus:outline focus:outline-2 focus:rounded-sm focus:outline-red-500"
                    >Log in</Link
                >

                <Link
                    v-if="canRegister"
                    :href="route('register')"
                    class="ml-4 cursor-pointer font-semibold text-gray-600 hover:text-gray-900 dark:text-gray-400 dark:hover:text-white focus:outline focus:outline-2 focus:rounded-sm focus:outline-red-500"
                    >Register</Link
                >
            </template>
        </div>

        <div class="max-w-7xl mx-auto p-6 lg:p-8">
            <div class="flex justify-center text-2xl p-3">
                <Link
                :href="route('marked_document')"
                class="ml-4 cursor-pointer font-semibold text-gray-600 hover:text-gray-900 dark:text-gray-400 dark:hover:text-white focus:outline focus:outline-2 focus:rounded-sm focus:outline-red-500"
                >Qanoniah</Link>
                
            </div>

            <div class="mt-16">

                <button @click="getSelection()" class="bg-green-600 text-gray-50 px-3 py-1 rounded-md shadow-md">Show selection</button>

                <div>
                    <p v-if="selectedText.length > 0" class="shadow-lg p-4 m-4">{{ selectedText }}</p>
                </div>
                <div id="qanoniah_text" contenteditable="true" @mouseup="getSelection()" class="shadow-lg p-4 m-4 text-right">
                    <div>
                        <p>
                            <a href="#"> قانونية </a>
                            هي منصة تقدم خدمات 
                            <a href="#"> مساندة للقانونيين </a>
                            وذلك بتوفير قاعدة بياصنات نوعية تشمل
                            أكثر من ثلاثين ألف مستند خاصًّا &nbsp; خاصاًّ 
                            <br> 
                            ووثيقة 
                            <a href="#"> قانونية </a>
                            متعلقة بالنظام السعودي، تتضمن قاعدة
                            البيانات &nbsp;
                            <br>
                            أحكام وقرارات وأنظمة ولوائح 
                            <a href="#"> وتعاميم </a>
                            ومبادئ ونماذج 
                            <a href="#"> استرشادية </a>
                            لعقود
                            ومذكرات 
                        </p>
                        
                        <p><br></p>
                        <div class="w-full">
                            <table border="1" cellpadding="1" cellspacing="1" class="w-full">
                                <tbody>
                                    <tr>
                                        <th rowspan="2"> الرقم </th>
                                        <th rowspan="2"> الخدمة </th>
                                        <th colspan="5" style="text-align:center"> مقدار الرسم </th>
                                        <th rowspan="2"> الوحدة </th>
                                    </tr>

                                    <tr>
                                        <th style="text-align:center">
                                            <p> التصنيف </p>
                                            <p> الاول </p>
                                        </th>
                                        <th style="text-align:center">
                                            <p> التصنيف </p>
                                            <p> الثاني </p>
                                        </th>
                                        <th style="text-align:center">
                                            <p> التصنيف </p>
                                            <p> الثالث </p>
                                        </th>
                                        <th style="text-align:center">
                                            <p> التصنيف </p>
                                            <p> الرابع </p>
                                        </th>
                                        <th style="text-align:center">
                                            <p> التصنيف </p>
                                            <p> الخامس </p>
                                        </th>
                                    </tr>

                                    <tr>
                                        <td>١</td>
                                        <td colspan="7" rowspan="1"><strong> اصدار تراخيص انشاء المباني </strong></td>
                                    </tr>

                                    <tr>
                                        <td>١-١</td>
                                        <td> المباني السكنية </td>
                                        <td style="text-align:center">٣٫٠٠</td>
                                        <td style="text-align:center">٤٫٠٠</td>
                                        <td style="text-align:center">٥٫٠٠</td>
                                        <td style="text-align:center">٦٫٠٠</td>
                                        <td style="text-align:center">٧٫٠٠</td>
                                        <td> لكل متر مربع </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                        

                        <p><br></p>
                        <ul>
                        <li> ١- شص </li>
                        <li>
                        ٢- شصيشص
                        <ul>
                        <li> ٣- شصيصش </li>
                        </ul>
                        </li>
                        </ul>
                    </div>
                </div>
            </div>

            <div class="flex justify-center mt-16 px-6 sm:items-center sm:justify-between">
                <div class="text-center text-sm text-gray-500 dark:text-gray-400 sm:text-left">
                    <div class="flex items-center gap-4">
                        &copy 2023 qanoniah 
                    </div>
                </div>

                
            </div>
        </div>
    </div>
</template>

